#!/usr/bin/perl

# Here we go again...GPLv2 will do C 2020 Doug Coulter
# as usual, if I thought it dodgy, I used @@@ in a nearby comment

use Modern::Perl '2014'; # we only have 5.18 on this machine?
#use File::Basename 'dirname'; # for knowing where we are (ease for developer) already here
use Cwd 'abs_path';
use Gtk3 -init; # for our GUI
use Glib  qw(TRUE FALSE); # for periodic events etc
#use Gtk3::Helper; # allows us to add "watch" callbacks to (file/socket) handles?
use Math::Trig; # to get pi, there's probably a faster way
use Scalar::Util qw(looks_like_number); # also slow but tests for numeric

# gobject issue is fixed in later distros
#http://askubuntu.com/questions/319568/i-cant-configure-rhythmbox-as-gobject-introspection-1-is-not-installed for when you can't install gtk3 or glib
#

#use Storable qw(nstore retrieve); # for (re) storing hash of hashes preset
#use DBI; # for mySQL interface
####################################################################
# GUI variable references to objects
my $GUIFilename; # @@@ generated below

my $builder = Gtk3::Builder->new(); # gtkbuilder object, creates a gui from glade's xml
my $mainwin; # will be set up in the creation routine
# put references to any other new created gui objects here for organization
my ($diar,$rpmr,$fpmr); # refs to entry objects
my ($dia,$rpm,$fpm) = (.375,1000,98.17477); # values

=pod
Usually I will put my GUI-related variables here, as pairs - one a reference to the widget,
one the value for that widget if it has one to retrieve or change.  So things look like this:

my $($widgetnamer,$widgetname); # reference to the thing for manipulation, and value

You can reuse the same name for the widget you used in Glade for ID if you like to keep your mind
free for other stuff.  This is an entirely different namespace.
Yes, this makes them all globals...the whole GUI is anyway.

=cut

####################################################################
# @@@ this has a hardcoded glade filename in a variable - you need to fix that as required
# @@@ above

sub createguifile # create the gui from xml in a .glade file 
{ # use this for developer convienience.  Final product should put glade xml
  # after the __END__ tag and use createguilocal instead
 $GUIFilename = abs_path($0);
 $GUIFilename =~ s/.pl//; # if it had this extension, wipe that
 $GUIFilename .= '.glade'; # @@@ assumptions
  #  say "GUIFilename: $GUIFilename";
 $builder->add_from_file($GUIFilename); # @@@ set that variable right, dumb ass
 $mainwin = $builder->get_object('mainwin'); #@@@ assumes main window is called mainwin
 $builder->connect_signals(undef);
 $mainwin->set_screen( $mainwin->get_screen() ); #??? from an example.  Seems redundant?
 $mainwin->signal_connect(destroy => sub {Gtk3->main_quit});
 $mainwin->show_all();
# not so program-specific you couldn't use it again
}
####################################################################
 sub getGUIrefs
 { # get all the references to the GUI widgets you need here, called in initialize
   # example:  $widgetnamer = $builder->get_object('widgetname'); # or ID?, I make them the same anyway
   $diar = $builder->get_object('diameter');
   $rpmr = $builder->get_object('rpm');
   $fpmr = $builder->get_object('fpm');

 }
####################################################################
 sub var2GUI
 { # at least for simpler things, this is where you'd stuff all the 
   # gui elements with the contents of the variables that go with them.
  $diar->set_text($dia);
  $rpmr->set_text($rpm);
  $fpmr->set_text($fpm);
 }
####################################################################
 sub GUI2var
 { # grab the content of any interesting widgets and put into variables here
  $dia = $diar->get_text();
  $rpm = $rpmr->get_text();
  $fpm = $fpmr->get_text();
 }
####################################################################
sub on_diabtn_clicked
{
 GUI2var();
  if (looks_like_number($fpm) & looks_like_number($dia))
 { 
     $dia = ($fpm*12)/($rpm*pi()); # 12 inch/foot into one constant
 } else {$dia = 'input error';}
 var2GUI();
}
####################################################################
sub on_rpmbtn_clicked
{
 GUI2var();
  if (looks_like_number($fpm) & looks_like_number($dia))
 { 
     $rpm = ($fpm*12)/($dia*pi()); # 12 inch/foot into one constant
 } else {$rpm = 'input error';}
 var2GUI();
}
####################################################################
sub on_fpmbtn_clicked
{
 GUI2var();
 if (looks_like_number($rpm) & looks_like_number($dia))
 { 
     $fpm = $rpm*$dia*pi()/12; # 12 inch/foot into one constant
 } else {$fpm = 'input error';}
 var2GUI();
}

####################################################################
# switch to using this once the gui is more or less settled - the file is easier to change
# but this is easier to ship.
sub createguilocal # create the gui from xml in a .glade file 
{ # put glade xml after the __END__ tag and use createguilocal
 my $guidata; # packed the xml internally, goes here
 local $/; # which makes this undefined for this sub
 $guidata = <main::DATA>; # which makes this slurp the entire "file"
 $builder = Gtk3::Builder->new_from_string($guidata,length($guidata));
 $mainwin = $builder->get_object('mainwin'); #@@@ assumes main window is called mainwin
 $builder->connect_signals(undef);
 $mainwin->set_screen( $mainwin->get_screen() ); #??? from an example.  Seems redundant?
 $mainwin->signal_connect(destroy => sub {Gtk3->main_quit});
 $mainwin->show_all();
}
####################################################################

sub initialize 
{ # put all your init code here

#	createguifile(); # you'll start out with this
	createguilocal(); # but use this one when shipping.  XML after the __END__ tag
    getGUIrefs(); # get references to the widgets for later messing around
    # setup any variables here for the call below
    var2GUI(); # you may want to put in some content you didn't do in Glade?
}
####################################################################


####################################################################
############################ Main ##################################
####################################################################

initialize();
#say "Compiled OK."; # way to say we made it.
 Gtk3->main; # GUI event forever loop - when we quit, we fall out and exit

# when your gui is settled, copy the xml from the glade file to below the end tag and use createguilocal
#instead.  Harder to change, easier to ship.
 __END__
<?xml version="1.0" encoding="UTF-8"?>
<!-- Generated with glade 3.22.1 -->
<interface>
  <requires lib="gtk+" version="3.20"/>
  <object class="GtkApplicationWindow" id="mainwin">
    <property name="name">mainwin</property>
    <property name="can_focus">False</property>
    <property name="title" translatable="yes">speeds n feeds calc</property>
    <child>
      <placeholder/>
    </child>
    <child>
      <object class="GtkGrid">
        <property name="visible">True</property>
        <property name="can_focus">False</property>
        <child>
          <object class="GtkLabel" id="dialbl">
            <property name="name">dialbl</property>
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">Diameter, inches </property>
          </object>
          <packing>
            <property name="left_attach">0</property>
            <property name="top_attach">0</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel" id="rpmlbl">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">RPM</property>
          </object>
          <packing>
            <property name="left_attach">0</property>
            <property name="top_attach">1</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">FPM</property>
          </object>
          <packing>
            <property name="left_attach">0</property>
            <property name="top_attach">2</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="diameter">
            <property name="name">diameter</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="width_chars">15</property>
            <property name="input_purpose">number</property>
          </object>
          <packing>
            <property name="left_attach">1</property>
            <property name="top_attach">0</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="rpm">
            <property name="name">rpm</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="width_chars">15</property>
            <property name="input_purpose">number</property>
          </object>
          <packing>
            <property name="left_attach">1</property>
            <property name="top_attach">1</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="fpm">
            <property name="name">fpm</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="width_chars">15</property>
            <property name="input_purpose">number</property>
          </object>
          <packing>
            <property name="left_attach">1</property>
            <property name="top_attach">2</property>
          </packing>
        </child>
        <child>
          <object class="GtkButton" id="diabtn">
            <property name="label" translatable="yes">Calculate Diameter</property>
            <property name="name">diabtn</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="receives_default">True</property>
            <signal name="clicked" handler="on_diabtn_clicked" swapped="no"/>
          </object>
          <packing>
            <property name="left_attach">2</property>
            <property name="top_attach">0</property>
          </packing>
        </child>
        <child>
          <object class="GtkButton" id="rpmbtn">
            <property name="label" translatable="yes">Calculate RPM</property>
            <property name="name">rpmbtn</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="receives_default">True</property>
            <signal name="clicked" handler="on_rpmbtn_clicked" swapped="no"/>
          </object>
          <packing>
            <property name="left_attach">2</property>
            <property name="top_attach">1</property>
          </packing>
        </child>
        <child>
          <object class="GtkButton" id="fpmbtn">
            <property name="label" translatable="yes">Calculate FPM</property>
            <property name="name">fpmbtn</property>
            <property name="visible">True</property>
            <property name="can_focus">True</property>
            <property name="receives_default">True</property>
            <signal name="clicked" handler="on_fpmbtn_clicked" after="yes" swapped="no"/>
          </object>
          <packing>
            <property name="left_attach">2</property>
            <property name="top_attach">2</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">Provide 2</property>
          </object>
          <packing>
            <property name="left_attach">0</property>
            <property name="top_attach">3</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">values above</property>
          </object>
          <packing>
            <property name="left_attach">1</property>
            <property name="top_attach">3</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="label" translatable="yes">calculate from other two</property>
          </object>
          <packing>
            <property name="left_attach">2</property>
            <property name="top_attach">3</property>
          </packing>
        </child>
      </object>
    </child>
  </object>
</interface>
